#!/usr/bin/env python
# -*- coding: utf-8 -*-

from flask import Flask, app, request, render_template
from utils import clean
from settings import db
import random

app = Flask(__name__)

@app.route("/")
@app.route("/index")
def index():
    from markov import Markov
    from chunk import Chunk
    import string
    
    chunks = []
    
    for speech in db.obama.find():
        chunks.append(Chunk(speech['clean_text']))

    generator = Markov(chunks)
    quote = generator.generate_markov_text(random.randrange(20,250))
    
    quote = string.upper(quote[0]) + quote[1:]
    
    return render_template('quote.html', quote=quote)

@app.route("/add", methods=['GET', 'POST'])
def add():
    if request.method == 'POST':
        db.obama.insert({
            'url': request.form['url'],
            'video_id': request.form['video_id'],
            'text': request.form['text'],
            'clean_text': clean(request.form['text'])
        })
        
    return render_template('form.html')

@app.route("/export")
def export():
    import json
    
    export = []
    
    for speech in db.obama.find():
        export.append({
            'url': speech['url'],
            'text': speech['text'],
            'cleaned_text': speech['clean_text'],
        })
    
    return json.dumps(export)
    
if __name__ == '__main__':
    app.run(host='localhost')